const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

var gFlickrsidebar = null;
function start()
{
  gFlickrsidebar = new Flickrsidebar();
  gFlickrsidebar.start();
};

function stop()
{
  gFlickrsidebar.stop();
  gFlickrsidebar = null;
};

function Flickrsidebar() {};
Flickrsidebar.prototype = {
  _branch: null,
  _bundle: null,
  _request: null,
  _frob: null,
  _current: 0,
  _total: 0,
  _timer: null,
  _photos: null,
  _index: null,
  _history: null,
  _ignoreFocus: false,
  _ignoreClick: false, 
  
  get branch() {
    if (!this._branch) {
      var pbs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      this._branch = pbs.getBranch("extensions.flickrsidebar."); 
    };
    return this._branch;
  },
  
  get bundle() {
    if (!this._bundle)
      this._bundle = document.getElementById("mainBundle");    
    return this._bundle;  
  },
 
  get token() {
    var value = this.branch.getComplexValue("api.token", Components.interfaces.nsISupportsString).data;
    if (!value)
      return null;
    else
      return value;  
  },
 
  set token(aValue) {
    var comp = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    comp.data = aValue;
    this.branch.setComplexValue("api.token", Components.interfaces.nsISupportsString, comp);
  },
  
  get url() {
    var value = this.branch.getComplexValue("api.url", Components.interfaces.nsISupportsString).data;
    if (!value)
      return null;
    else
      return value;  
  },
 
  get key() {
    var value = this.branch.getComplexValue("api.key", Components.interfaces.nsISupportsString).data;
    if (!value)
      return null;
    else
      return value;  
  },
 
  get secret() {
    var value = this.branch.getComplexValue("api.secret", Components.interfaces.nsISupportsString).data;
    if (!value)
      return null;
    else
      return value;  
  },
  
  get priority() {
    return this.branch.getIntPref("photos.priority");
  },
  
  get timeout() {
    return this.branch.getIntPref("photos.timeout");
  },
  
  get count() {
    return this.branch.getIntPref("photos.count");
  },
  
  get size() {
    return this.branch.getCharPref("photos.size");
  },
     
  get nsid() {
    var value = this.branch.getComplexValue("photos.nsid", Components.interfaces.nsISupportsString).data;
    if (!value)
      return null;
    else
      return value;  
  },
 
  set nsid(aValue) {
    var comp = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    comp.data = aValue;
    this.branch.setComplexValue("photos.nsid", Components.interfaces.nsISupportsString, comp);
  },
  
  get group() {
    return this.branch.getBoolPref("photos.group");
  },
  
  set group(aValue) {
    this.branch.setBoolPref("photos.group", aValue);
  },
                
  start: function()
  {
    //hookup history
    //this._history = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory);
    
    //check that we have the need api values
    if (!this.checkAPI()) {
      this.setMessage("api");
      return;
    };

    //add preference observer
    var pbi = this.branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    pbi.addObserver("", this, false);
        
    //request frob if token doesn't exist
    if (!this.token)
      this.getFrob();   
    else
      this.checkToken();
  },
  
  stop: function()
  {
    //cancel pending requests
    this.cancelRequests();
    
    //remove preference observer
    try {
      var pbi = this._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
      pbi.removeObserver("", this);
    } catch(e) {};
        
    //remove variables;
    this._branch = null;
    this._bundle = null;
    this._request = null;
    this._frob = null;
    this._current = null;
    this._total = null;
    this._timer = null;
    this._photos = null;
    this._index = null;
    this._history = null;
    this._ignoreFocus = null;
    this._ignoreClick = null;     
  },
  
  delayedStart: function()
  {           
    //determine stream to show
    var popup = document.getElementById("photosPopup");
    var item = null;
    var event = {};    
    for (var i=0; i< popup.childNodes.length; i++) {
      item = popup.childNodes[i];
      if (item.getAttribute("nsid") != this.nsid)
        continue;
        
      //found item
      item.setAttribute("checked", "true");
      event.originalTarget = item;
      this.showPhotos(event);
      return;
    };
                    
    //selected stream could not be found
    //so select everyones by default
    item = document.getElementById("everyones");
    item.setAttribute("checked", "true");
    event.originalTarget = item;
    this.showPhotos(event);
  },
    
  openOptions: function()
  {
    //get options window
    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
    var options = windowManager.getMostRecentWindow("flickrsidebar:options");

    //focus window
    if (options)
      options.focus();
    else
      window.open("chrome://flickrsidebar/content/options.xul", "_blank", "chrome,modal,dialog");
  },
  
  openPhoto: function(aEvent, aWhere)
  {
    //nothing selected
    var item = document.getElementById("photosBox").selectedItem;
    if (!item)
      return;
          
    //get where value
    if (!aWhere)
      aWhere = this.whereToOpenLink(aEvent, false, false);
      
    //open link
    this.openUILinkIn(item.getAttribute("url"), aWhere);  
  },
    
  checkMiddleClick: function(aEvent)
  {
    //nothing selected
    var item = document.getElementById("photosBox").selectedItem;
    if (!item)
      return;
    
    //middle click  
    if (aEvent.button == 1)  
      this.openPhoto(aEvent);    
  },
    
  showMorePhotos: function(aIncrement)
  {    
    this._current = this._current + aIncrement;
	this.getPhotos();      
  },
  
  showPhotos: function(aEvent)
  {
    //reset page variables
    this._current = 1;
    this._total = 1;   
    
    //get stream to search
    if (aEvent) {
      var item = aEvent.originalTarget;
      var search = document.getElementById("searchBox");
      search.setAttribute("tooltiptext", item.getAttribute("label"));
      this.nsid = item.getAttribute("nsid");
      this.group = (item.getAttribute("group") == "true") ? true : false;
    };
	this.getPhotos();               
  },
  
  getPhotos: function()
  {
    //cancel previous request
    this.cancelRequests();
    
    //set throbber and message
    this.setThrobber(true);
    this.updateUI(true);
	
	//send request
	this.setRequest(this.buildURL(), "getPhotos");      
  },  
  
  updateContext: function()
  {
    var item = document.getElementById("photosBox").selectedItem;
    var open = document.getElementById("cmdOpen");
    var opentab = document.getElementById("cmdOpenTab");    
    var openwindow = document.getElementById("cmdOpenWindow");
      
    //set disabled    
    if (!item) {
      open.setAttribute("disabled", "true");
      opentab.setAttribute("disabled", "true");
      openwindow.setAttribute("disabled", "true"); 
    } else {
      open.removeAttribute("disabled");
      opentab.removeAttribute("disabled"); 
      openwindow.removeAttribute("disabled");
    };
  },
    
  checkToken: function()
  {
    //set throbber and message
    this.setThrobber(true);    
    this.updateUI(false);
    
    //create url
	var url = this.url + "?method=flickr.auth.checkToken" + "&api_key=" + this.key + "&auth_token=" + this.token;
	
	//send request
	this.setRequest(url, "checkToken");
  },
  
  getFrob: function()
  {
    //set throbber and message
    this.setThrobber(true);    
    this.updateUI(false);
    
    //create url and signature
	var signed = MD5(this.secret + "api_key" + this.key + "method" + "flickr.auth.getFrob");
	var url = this.url + "?method=flickr.auth.getFrob" + "&api_key=" + this.key + "&api_sig=" + signed;

    //send request
    this.setRequest(url, "getFrob");   
  },

  getToken: function()
  {    
    //set throbber and message
    this.setThrobber(true);    
    this.updateUI(false);
    
    //create url and signature
	var signed = MD5(this.secret + "api_key" + this.key + "frob" + this._frob + "method" + "flickr.auth.getToken");
	var url = this.url + "?method=flickr.auth.getToken" + "&api_key=" + this.key + "&frob=" + this._frob + "&api_sig=" + signed;

    //send request
    this.setRequest(url, "getToken");    
  },
    
  getContacts: function()
  {
    //set throbber and message
    this.setThrobber(true);    
    this.updateUI(false);
        
    //create url
	var url = this.url + "?method=flickr.contacts.getList" + "&api_key=" + this.key + "&auth_token=" + this.token;
	
	//send request
	this.setRequest(url, "getContacts");  
  },
  
  getGroups: function()
  {
    //set throbber and message
    this.setThrobber(true);    
    this.updateUI(false);
        
    //create url
	var url = this.url + "?method=flickr.groups.pools.getGroups" + "&api_key=" + this.key + "&auth_token=" + this.token;
	
	//send request
	this.setRequest(url, "getGroups");  
  },
  
  onLoad: function()
  {
    //stop timer and throbber
    this.setThrobber(false);
    this._request.timer.cancel();
    try {
      window.clearTimeout(this._timer);
    } catch(e) {};
    
    //check server response
    try {
      var status = this._request.status;
    } catch (e) {
      status = -1;
    };
      
    switch (status) {
      case 407:
        this.setMessage("proxy");
        return;
      case -1:
        this.setMessage("contact");
        return;
      default:
        if (status > 200) {
          this.setMessage("status");
          return;
        };
    };
         
    //check response document
    if (this._request.responseText == "") {
      this.setMessage("response");
      return;
    };
    if (this._request.responseXML.childNodes[0].localName == "parsererror") {
      this.setMessage("response");
      return;    
    };
              
    //call finish function
    switch (this._request.callback) {
      case "checkToken":
        this.onCheckToken();
        break;    
      case "getFrob":
        this.onGetFrob();
        break;
      case "getToken":
        this.onGetToken();
        break;
      case "getContacts":
        this.onGetContacts();
        break;        
      case "getGroups":
        this.onGetGroups();
        break;
      case "getPhotos":
        this.onGetPhotos();
        break;                 
    };
  },
        
  onCheckToken: function()
  {
    //parse response
    var response = this._request.responseXML.getElementsByTagName("rsp")[0];
    var state = response.getAttribute("stat");
    if (state == "fail") {
      var err = response.getElementsByTagName("err")[0];
      var code = err.getAttribute("code");
      if (code == "98")
        this.getFrob();
      else
        this.setMessage("error");
      return;
    };
    
    //set token
    var tokenEl = response.getElementsByTagName("token")[0];
    var token = tokenEl.firstChild.nodeValue;
    this.token = token;
        
    //set nsid 
    var user = response.getElementsByTagName("user")[0];
    var nsid = user.getAttribute("nsid");
    var yours = document.getElementById("yours");
    yours.setAttribute("nsid", nsid);
        
    //load contacts
    this.getContacts();
  },
  
  onGetFrob: function()
  {
    //parse response
    var response = this._request.responseXML.getElementsByTagName("rsp")[0];
    var state = response.getAttribute("stat");
    if (state == "fail") {
      this.setMessage("error");
      return;
    };
    
    //create url to visit
	var frobEl = response.getElementsByTagName("frob")[0];
	this._frob = frobEl.firstChild.nodeValue;
	var signed = MD5(this.secret + "api_key" + this.key + "frob" + this._frob + "permsread");
	var url = "http://flickr.com/services/auth/?api_key=" + this.key + "&perms=read" + "&frob=" + this._frob + "&api_sig=" + signed;

    //opening a new focused tab.
    var browser = window.parent.getBrowser();    
    var tab = browser.addTab(url);
    browser.selectedTab = tab;
    
    //set authentication message
    this.setMessage("auth");
  },

  onGetToken: function()
  {
    //parse response
    var response = this._request.responseXML.getElementsByTagName("rsp")[0];
    var state = response.getAttribute("stat");
    if (state == "fail") {
      this.setMessage("error");
      return;
    };
    
    //set token
    var tokenEl = response.getElementsByTagName("token")[0];
    var token = tokenEl.firstChild.nodeValue;
    this.token = token;
    
    //set nsid 
    var user = response.getElementsByTagName("user")[0];
    var nsid = user.getAttribute("nsid");
    var yours = document.getElementById("yours");
    yours.setAttribute("nsid", nsid);
    
    //load contacts
    this.getContacts();  
  },
  
  onGetContacts: function()
  {
    //get elements
    var popup = document.getElementById("photosPopup");
    var separator = document.getElementById("contactsSeparator");
    var groups = document.getElementById("groupsSeparator"); 
    
    //hide contacts seperator
    separator.setAttribute("hidden", "true");
    
    //parse response
    var response = this._request.responseXML.getElementsByTagName("rsp")[0];
    var state = response.getAttribute("stat");
    if (state == "fail") {
      this.getGroups();
      return;
    };
    
    //build contact list
    var contacts = response.getElementsByTagName("contact");
    for (i=0; i<contacts.length; i++) {
      var contact = contacts[i];
      item = document.createElementNS(XUL_NS, "menuitem");
      item.setAttribute("label", contact.getAttribute("realname"));
      item.setAttribute("nsid", contact.getAttribute("nsid"));
      item.setAttribute("group", "false");
      item.setAttribute("type",  "radio");
      popup.insertBefore(item, groups);      
    };
    
    //show contacts separator
    if (contacts.length > 0)
      separator.removeAttribute("hidden");
      
    //get groups
    this.getGroups();        
  },
  
  onGetGroups: function()
  {
    //get elements
    var popup = document.getElementById("photosPopup");
    var separator = document.getElementById("groupsSeparator");
    
    //hide groups seperator
    separator.setAttribute("hidden", "true");

    //parse response
    var response = this._request.responseXML.getElementsByTagName("rsp")[0];
    var state = response.getAttribute("stat");
    if (state == "fail") {
      this.delayedStart();
      return;
    };
    
    //build group list
    var groups = response.getElementsByTagName("group");
    for (i=0; i<groups.length; i++) {
      var group = groups[i];
      item = document.createElementNS(XUL_NS, "menuitem");
      item.setAttribute("label", group.getAttribute("name"));
      item.setAttribute("nsid", group.getAttribute("nsid"));
      item.setAttribute("group", "true");
      item.setAttribute("search", "false");      
      item.setAttribute("type",  "radio");
      popup.appendChild(item);      
    };
    
    //show groups separator
    if (groups.length > 0)
      separator.removeAttribute("hidden");
      
    //show first photos
    this.delayedStart();          
  },
  
  onGetPhotos: function()
  {
    //parse response
    var response = this._request.responseXML.getElementsByTagName("rsp")[0];
    var state = response.getAttribute("stat");
    if (state == "fail") {
      return;
    };
    
    //clear old images
	var box = document.getElementById("photosBox");
	while (box.hasChildNodes())
	  box.removeChild(box.lastChild);
  
    //set current and total pages
    var photosEl = response.getElementsByTagName("photos")[0];
    this._current = parseInt(photosEl.getAttribute("page"));
    this._total = parseInt(photosEl.getAttribute("pages"));
    
    //update UI
    this.updateUI(true);
    
    //start displaying images
	this._photos = response.getElementsByTagName("photo");
	this._index = 0;
	this.addPhoto();
  },
   
  setThrobber: function(aLoading)
  {
    var throbber = window.parent.document.getElementById("sidebar-throbber");
    if (aLoading)
      throbber.setAttribute("loading", "true");
    else
      throbber.removeAttribute("loading");
  },
  
  setMessage: function(aType, aNode)
  {
    //get elements
    var title = document.getElementById("messageTitle");
    var description = document.getElementById("messageDescription"); 
    var button = document.getElementById("messageButton");
    var deck = document.getElementById("contentDeck");
    
    //remove previous description
    while (description.hasChildNodes())
      description.removeChild(description.lastChild);
    
    //set new message attributes
    title.setAttribute("value", this.bundle.getString(aType + ".title"));
    if (aType != "error" && aType != "status")
      description.appendChild(document.createTextNode(this.bundle.getString(aType + ".description")));    
    button.setAttribute("label", this.bundle.getString("again.label"));
    button.setAttribute("accesskey", this.bundle.getString("again.accesskey")); 
    button.setAttribute("oncommand", "gFlickrsidebar." + this._request.callback + "();");
    
    //set specific overrides          
    switch (aType) {
      case "api":
        button.setAttribute("oncommand", "gFlickrsidebar.start();");
        break;
      case "error":
        var response = this._request.responseXML.getElementsByTagName("rsp")[0];
        var err = response.getElementsByTagName("err")[0];
        description.appendChild(document.createTextNode(err.getAttribute("msg")));
        break;
      case "status":
        var status = this.bundle.getFormattedString("status.description", [this._request.status]);
        description.appendChild(document.createTextNode(status));
        break;
      case "auth":
        button.setAttribute("label", this.bundle.getString("done.label"));
        button.setAttribute("accesskey", this.bundle.getString("done.accesskey"));
        button.setAttribute("oncommand", "gFlickrsidebar.getToken();");
        break;  
    };
    
    //show message
    deck.selectedIndex = 1;
  },
  
  setRequest: function(aURL, aCallback)
  {
    var component = this;  
    this._request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
    this._request.timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
    this._request.overrideMimeType("text/xml");
    this._request.open("GET", aURL, true);   
    if (this._request.channel instanceof Components.interfaces.nsISupportsPriority)
      this._request.channel.priority = this.priority;
      
    this._request.callback = aCallback;
    this._request.onload = function() { component.onLoad(); };
    this._request.onerror = function() { component.onLoad(); };
    
    //fire request
    this._request.timer.initWithCallback(this, this.timeout * 1000, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
    this._request.send(null); 
  },

  updateUI: function(aEnabled)
  { 
    //get elements
    var deck = document.getElementById("contentDeck");
    var search = document.getElementById("searchBox");
    var select = document.getElementById("selectButton");
    var previous = document.getElementById("cmdPrevious");
    var next = document.getElementById("cmdNext");
    
    //enable ui
    if (aEnabled) {
      select.removeAttribute("disabled"); 
      
      //can not search everyones   
      if (this.nsid == "favorites")
        search.setAttribute("disabled", "true");
      else
        search.removeAttribute("disabled");
        
      //on first page
      if (this._current > 1) {
        previous.removeAttribute("disabled");
        previous.setAttribute("tooltiptext", this.bundle.getFormattedString("page.tooltip", [this._current - 1, this._total]));
      } else {
        previous.setAttribute("disabled", "true");
        previous.setAttribute("tooltiptext", this.bundle.getString("previous.tooltip"));
      };
        
      //on last page
      if (this._current < this._total) {
        next.removeAttribute("disabled");
        next.setAttribute("tooltiptext", this.bundle.getFormattedString("page.tooltip", [this._current + 1, this._total]));
      } else {
        next.setAttribute("disabled", "true");
        next.setAttribute("tooltiptext", this.bundle.getString("next.tooltip"));
      };
        
    //disable ui   
    } else {
      search.setAttribute("disabled", "true");
      select.setAttribute("disabled", "true");      
      previous.setAttribute("disabled", "true");
      next.setAttribute("disabled", "true");
      previous.setAttribute("tooltiptext", this.bundle.getString("previous.tooltip"));
      next.setAttribute("tooltiptext", this.bundle.getString("next.tooltip"));
    };
    
    //show photo box
    deck.selectedIndex = 0;
  },
  
  buildURL: function()
  {
	//build url	    
    var url = this.url;
	var search = this.cleanupSearch();    	    
    if (this.nsid == "everyones" && !search)
      url += "?method=flickr.photos.getRecent" + "&api_key=" + this.key;
    else if (this.nsid == "everyones")
      url += "?method=flickr.photos.search" + "&api_key=" + this.key;    
    else if (this.nsid == "favorites")
      url += "?method=flickr.favorites.getList" + "&api_key=" + this.key;
    else {
      if (this.group) {
        url += "?method=flickr.groups.pools.getPhotos" + "&api_key=" + this.key;
        url += "&group_id=" + this.nsid;
      } else {
        url += "?method=flickr.photos.search" + "&api_key=" + this.key;
        url += "&user_id=" + this.nsid;
      };
    };
	
	//set tags
	if (search && this.nsid != "favorites") {
	  url += "&tags=" + search;	  
	};
	url += "&per_page=" + this.count;
	url += "&page=" + this._current;
	url += "&auth_token=" + this.token;
    return url;  
  },
  
  addPhoto: function()
  {
    //no photos in stream
    if (this._photos.length <= 0) {
      this.setThrobber(false);
      return;
    };
    
    //all photos displayed
    if (this._index >= this._photos.length) {
      this.setThrobber(false);
      return;
    };
    
    //create placeholders
    var box = document.getElementById("photosBox");
    var item = null;
    if (this._index == 0) {
      this.setThrobber(true);
      for (var x=0; x<this._photos.length; x++) {
        item = this.createPhoto(this._photos[x]);
        box.appendChild(item); 
      };
    };
    
    //display the next photo
    this.setThrobber(true);
    item = box.getItemAtIndex(this._index);
    item.firstChild.setAttribute("src", item.getAttribute("imgurl"));

    //set timeout to show photo
    ++this._index;
    this._timer = window.setTimeout("gFlickrsidebar.addPhoto();", 20); 
  },
  
  createPhoto: function(aPhoto)
  {
    //get photo properties
    var server = aPhoto.getAttribute("server");
    var id = aPhoto.getAttribute("id");
    var secret = aPhoto.getAttribute("secret");
    var user = aPhoto.getAttribute("owner");
    var title = aPhoto.getAttribute("title");
            
    //create image
    var image = document.createElementNS(XUL_NS, "image");
    var imgurl = "http://static.flickr.com/" + server + "/" + id + "_" + secret + "_" + this.size + ".jpg"
    image.setAttribute("src", "resource://gre/res/loading-image.gif");
    image.setAttribute("validate", "never");
    image.setAttribute("tooltiptext", title);
        
    //create item
    var item = document.createElementNS(XUL_NS, "richlistitem");
    var url = "http://www.flickr.com/photos/" + user + "/" + id + "/";
    item.setAttribute("tooltiptext", title);
    item.setAttribute("url", url);
    item.setAttribute("pid", id);  
    item.setAttribute("imgurl", imgurl);
    item.appendChild(image);
    return item;  
  },
    
  checkAPI: function()
  {
    if (!this.url)
      return false;
      
    if (!this.key)
      return false;
       
    if (!this.secret)
      return false;
                 
    return true;
  },
  
  cancelRequests: function()
  {
    //stop window timer
    try {
      window.clearTimeout(this._timer);
    } catch(e) {};
    
    //check request  
    if (!this._request)
      return;
      
    //abort request
    try {
      this._request.abort();
    } catch(e) {};
    
    //stop request timer
    try {
      this._request.timer.cancel();
    } catch(e) {};
  },
  
  cleanupSearch: function()
  {
    //get search term
    var term = document.getElementById("searchBox").value;

    //replace spaces with commas
    if (term) {
      try {
        /// this._history.addEntry("flickrsidebar", term);
        if (this._history) this._history.addEntry("flickrsidebar", term);
      } catch(e) {};
      term = term.replace(/[\s]+/g, ",");
    };
      
    return term;  
  },
  
  ///////////////////////////
  // nsITimerCallback
  notify: function(timer)
  {
    //stop throbber and request
    this.setThrobber(false);
    this._request.abort();
    try {
      window.clearTimeout(this._timer);
    } catch(e) {};
        
    //set message
    this.setMessage("timeout");
  },

  /////////////////////////////
  // nsIObserver
  observe: function(aSubject, aTopic, aData)
  {
    //only worry about display options
    if (aData != "photos.size" && aData !="photos.count")
      return;
    
    //reload display  
    window.setTimeout("gFlickrsidebar.getPhotos();", 20);
  },
       
  ///////////////////////////
  // nsISupports   
  QueryInterface: function (aIID)
  {       
    if (!aIID.equals(Components.interfaces.nsISupports) &&
        !aIID.equals(Components.interfaces.nsITimerCallback) &&
        !aIID.equals(Components.interfaces.nsIObserver))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  },

  ///////////////////////////
  // Support for Firefox functions not in Seamonkey's utilityOverlay.js.

  gPrefs : Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch),
                
  // openUILink handles clicks on UI elements that cause URLs to load.
  openUILink : function ( url, e, ignoreButton, ignoreAlt )
  {
    var where = this.whereToOpenLink(e, ignoreButton, ignoreAlt);
    this.openUILinkIn(url, where, false);
  },

  whereToOpenLink : function ( e, ignoreButton, ignoreAlt )
  {
    if (e == null)
      e = { shiftKey:false, ctrlKey:false, metaKey:false, altKey:false, button:0 };

    var shift = e.shiftKey;
    var ctrl =  e.ctrlKey;
    var meta =  e.metaKey;
    var alt  =  e.altKey && !ignoreAlt;

    // ignoreButton allows "middle-click paste" to use function without always opening in a new window.
    var middle = !ignoreButton && e.button == 1;
    var middleUsesTabs = this.gPrefs.getBoolPref("browser.tabs.opentabfor.middleclick", true);

    // Don't do anything special with right-mouse clicks.  They're probably clicks on context menu items.

  //@line 170 "/cygdrive/c/builds/tinderbox/Fx-Trunk-Cairo/WINNT_5.2_Depend/mozilla/browser/base/content/utilityOverlay.js"
    if (ctrl || (middle && middleUsesTabs)) {
  //@line 172 "/cygdrive/c/builds/tinderbox/Fx-Trunk-Cairo/WINNT_5.2_Depend/mozilla/browser/base/content/utilityOverlay.js"
      if (shift)
        return "tabshifted";
      else
        return "tab";
    }
    else if (alt) {
      return "save";
    }
    else if (shift || (middle && !middleUsesTabs)) {
      return "window";
    }
    else {
      return "current";
    }
  },

  openUILinkIn : function ( url, where, allowThirdPartyFixup )
  {
    if (!where)
      return;

    if ((url == null) || (url == "")) 
      return;
    // xlate the URL if necessary
    if (url.indexOf("urn:") == 0) {
        url = xlateURL(url);        // does RDF urn expansion
    }
    // avoid loading "", since this loads a directory listing
    if (url == "") {
        url = "about:blank";
    }

    if (where == "save") {
      saveURL(url, null, null, true);
      return;
    }

    var w = (where == "window") ? null : getTopWin();
    if (!w) {
      openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url);
      return;
    }
    var browser = w.document.getElementById("content");

    switch (where) {
    case "current":
      browser.loadURI(url);
      w.content.focus();
      break;
    case "tabshifted":
    case "tab":
      var loadInBackground = this.gPrefs.getBoolPref("browser.tabs.loadInBackground", "false");
//      browser.loadOneTab(url, null, null, null, loadInBackground,
//                         allowThirdPartyFixup || false);
        browser.addTab(url, null, null, !loadInBackground);
      break;
    }
  }
}